#
# Cookbook Name:: vs
# Recipe:: default
#
# Copyright (C) 2016 YOUR_NAME
#
# All rights reserved - Do Not Redistribute
#

include_recipe 'ec2helper'


admin_xml = "#{Chef::Config[:cache_path]}/AdminDeployment.xml"
dirToDelete = 'c:/users/default/AppData'

cookbook_file "AdminDeployment.xml" do
	path "#{admin_xml}"
end

directory "#{node[:vs][:remote_file][:path]}" do
	action :create
end

remote_file "#{node[:vs][:remote_file][:path]}/#{node[:vs][:iso_name]}" do
	source "#{node[:vs][:remote_file][:source]}"
	not_if { File.exist?("#{node[:vs][:remote_file][:path]}/#{node[:vs][:iso_name]}") }
end

ec2helper_iso 'MountvsIso' do
	volume_name "#{node[:vs][:ec2helper_iso][:volume_name]}"
	iso_filename "#{node[:vs][:iso_name]}"
	iso_path "#{node[:vs][:remote_file][:path]}"
end

execute 'Install Visual Studio' do
	command lazy {"start /high /wait cmd /c #{node[:ec2helper][:iso][:mount][:drive_letter]}:/vs_professional.exe /quiet /ADMINFILE #{admin_xml}" }
	timeout 43200
	returns [0,3010]
	not_if { File.exist?("C:/Program Files (x86)/Microsoft Visual Studio 14.0/Common7/IDE/devenv.exe") }
	notifies :delete, "directory[#{dirToDelete}]", :immediately
end


directory "#{dirToDelete}" do
	recursive true
	action :nothing
	notifies :request_reboot, 'reboot[app_requires_reboot]', :immediately
	only_if { ::File.directory?(dirToDelete) }
end

reboot 'app_requires_reboot' do
  reason 'Need to reboot when the run completes successfully.'
  action :nothing
end


